<template>
  <div>
    <div class="personal-appeal"><span>{{ firstName }}</span>, для полного доступа к платформе нужно пройти аккредитацию. Заполните ещё несколько полей и прикрепите документы, пожалуйста.</div>

    <individual-entrepreneur v-if="userType === 'IP'" />

    <legal-entity
      v-if="userType === 'UL'"
      id="registration-legal"
    />

    <div id="registration-passport-info">
      <div class="step-heading">Паспорт <span v-if="userType === 'UL'">гендира</span><sup>*</sup></div>
      <div class="row">
        <div class="col-xs-12">
          <ob-checkbox
            label="Паспорт РФ"
            v-model="isRussianId"
            @change="clearIdData"
          />
        </div>
      </div>
      <div v-if="isRussianId">
        <div class="row">
          <div class="col-xs-6">
            <ob-input
              label="Серия и номер"
              placeholder="0000 000000"
              :required="true"
              :is-valid="isIdValid"
              v-model="formData.passport_number"
              @input="onChangeFormData('passport_number')"
            />
          </div>
          <div class="col-xs-6">
            <ob-datepicker
              ref="issuedDateDatepicker"
              label="Дата выдачи"
              placeholder="Укажите дату"
              :required="true"
              :is-valid-date="!!formData.issued_date"
              v-model="formData.issued_date"
              @blur="setDatepickerDirty('issuedDateDatepicker')"
              @input="onChangeFormData('issued_date')"
            />
          </div>
        </div>
        <div class="row">
          <div class="col-xs-6">
            <ob-datepicker
              ref="dobDatepicker"
              label="Дата рождения"
              placeholder="Укажите дату"
              :required="true"
              :is-valid-date="!!formData.dob"
              v-model="formData.dob"
              @blur="setDatepickerDirty('dobDatepicker')"
              @input="onChangeFormData('dob')"
            />
          </div>
        </div>
      </div>
      <div v-else>
        <div class="row">
          <div class="col-xs-12">
            <ob-textarea
              :label="`Паспортные данные${userType === 'UL' ? ' гендира' : ''}`"
              placeholder="Введите в свободном формате"
              :required="true"
              v-model="formData.passport"
              @input="onChangeFormData('passport')"
            />
          </div>
        </div>
      </div>
    </div>

    <div id="registration-passport-photo">
      <div class="step-paragraph">Разворот паспорта с фотографией (необязательно)</div>
      <div class="row">
        <div class="col-xs-12">
          <ob-uploader
            icon="excel"
            data-qa="uploader"
            :upload-method="uploadMethod"
            :upload-options="uploadOptions"
            @process-start="onFilesProcessStart"
            @change="onChangeFiles($event, 'passportFileUuid')"
          />
        </div>
      </div>
    </div>

    <div id="registration-bank">
      <div class="step-heading">Основной расчётный счёт</div>
      <div class="row">
        <div class="col-xs-12">
          <ob-input
            label="БИК"
            placeholder="Укажите БИК"
            :required="true"
            :is-valid="isBikValid"
            v-model="formData.bik"
            @input="onChangeFormData('bik')"
          />
        </div>
      </div>
      <div v-if="formData.bik && isBikValid">
        <div class="row">
          <div class="col-xs-12">
            <ob-input
              label="Наименование банка"
              placeholder="Наименование банка"
              :required="true"
              :disabled="true"
              v-model="formData.bank"
              @input="onChangeFormData('bank')"
            />
          </div>
        </div>
        <div class="row">
          <div class="col-xs-12">
            <ob-input
              label="Корр. счёт"
              placeholder="Корр. счёт"
              :required="true"
              :disabled="true"
              v-model="formData.correspondent_account"
              @input="onChangeFormData('correspondent_account')"
            />
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-xs-12">
          <ob-input
            label="Номер расчётного счёта"
            placeholder="Состоит из 20 цифр"
            :required="true"
            :is-valid="isPaymentAccountValid"
            v-model="formData.payment_account"
            @input="onChangeFormData('payment_account')"
          />
        </div>
      </div>
    </div>

    <div class="step-heading">Дополнительные документы</div>
    <div class="step-paragraph">ИНН (необязательно)</div>
    <div class="row">
      <div class="col-xs-12">
        <ob-uploader
          icon="excel"
          data-qa="uploader"
          :upload-method="uploadMethod"
          :upload-options="uploadOptions"
          @process-start="onFilesProcessStart"
          @change="onChangeFiles($event, 'innFileUuid')"
        />
      </div>
    </div>

    <div
      id="registration-submit"
      class="row button-row"
    >
      <div class="col-xs-12">
        <ob-button
          label="Отправить на проверку"
          :isFullWidth="true"
          :disabled="isDisabled || isFilesPending"
          @click="onSubmit"
        />
      </div>
    </div>

    <Tour :steps="steps" />
  </div>
</template>

<script>
  import api from '@/api'
  import { mapGetters, mapActions } from 'vuex'
  import debounce from 'debounce'

  import ObInput from 'common-components/src/obComponents/obInput'
  import ObTextarea from 'common-components/src/obComponents/obTextarea'
  import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
  import ObButton from 'common-components/src/obComponents/obButton'
  import ObUploader from 'common-components/src/obComponents/obUploader'
  import ObDatepicker from 'common-components/src/obComponents/obDatePickerConstructor'

  import IndividualEntrepreneur from './ip'
  import LegalEntity from './ul'
  import Tour from '../../components/Tour'

  export default {
    name: 'RegistrationFourthStep',
    components: {
       ObInput,
       ObTextarea,
       ObCheckbox,
       ObButton,
       ObUploader,
       ObDatepicker,
       IndividualEntrepreneur,
       LegalEntity,
       Tour
    },
    computed: {
      ...mapGetters({
        userUuid: 'user/userUuid',
        accreditationFormData: 'entry/accreditationFormData'
      }),

      isDisabled: ({ userType, accreditationFormData, isPaymentAccountValid }) => {
        switch (userType) {
          case 'IP': {
            const requiredFields = (({
              bik, bank, correspondent_account, payment_account
            }) => ({
              bik, bank, correspondent_account, payment_account
            }))(accreditationFormData);

            const requiredVariableFieldsFilled =
              (accreditationFormData.passport_number && accreditationFormData.issued_date && accreditationFormData.dob) ||
              (accreditationFormData.passport)

            return Object.values(requiredFields).some(value => !value) || !requiredVariableFieldsFilled || !isPaymentAccountValid;
          }

          case 'UL': {
            const requiredFields = (({
              ceo_firstname, ceo_lastname, bik, bank, correspondent_account, payment_account
            }) => ({
              ceo_firstname, ceo_lastname, bik, bank, correspondent_account, payment_account
            }))(accreditationFormData);

            const requiredVariableFieldsFilled =
              (accreditationFormData.passport_number && accreditationFormData.issued_date && accreditationFormData.dob) ||
              (accreditationFormData.passport)

            return Object.values(requiredFields).some(value => !value) || !requiredVariableFieldsFilled || !isPaymentAccountValid;
          }
        }
      },
      isPaymentAccountValid:({ accreditationFormData }) => accreditationFormData.payment_account.length === 20,
      steps () {
        if (this.userType === 'IP') {
          return [
            {
              target: '#registration-passport-info',
              header: { title: 'Ваши паспортные данные' },
              content: '<p>Мы не передаем личные данные третьим лицам и соблюдаем ФЗ №152.</p>' +
                       '<p>Введенные данные ускорят процесс верификации.</p>',
              params: { placement: 'right', highlight: true }
            },
            {
              target: '#registration-passport-photo',
              header: { title: 'Разворот паспорта ИП' },
              content: 'Вы можете загрузить скан первой страницы паспорта ИП и тогда процесс проверки пройдет быстрее',
              params: { placement: 'right', highlight: true }
            },
            {
              target: '#registration-bank',
              header: { title: 'Реквизиты счёта' },
              content: 'Данные по расчетному счету будут видеть клиенты платформы - это ускорит процесс оплаты заказов',
              params: { placement: 'right', highlight: true }
            },
            {
              target: '#registration-submit',
              header: { title: 'Проверка' },
              content: 'Вы уже сейчас сможете просматривать реальные заказы, ' +
                       'а итоговая проверка закончится в течение 2 часов.',
              params: { placement: 'right', highlight: true }
            }
          ]
        } else {
          return [
            {
              target: '#registration-legal',
              header: { title: 'Генеральный директор' },
              content: '<p>Мы не передаем личные данные третьим лицам и соблюдаем ФЗ №152.</p>' +
                       '<p>Введенные данные ускорят процесс верификации.</p>',
              params: { placement: 'right', highlight: true, enableScrolling: false }
            },
            {
              target: '#registration-passport-photo',
              header: { title: 'Разворот паспорта гендира' },
              content: 'Вы можете загрузить скан первой страницы паспорта генерального ' +
                       'директора и тогда процесс проверки пройдет быстрее',
              params: { placement: 'right', highlight: true }
            },
            {
              target: '#registration-bank',
              header: { title: 'Реквизиты счёта' },
              content: '<p>Данные по расчетному счету будут видеть клиенты платформы.</p>' +
                       '<p>Это ускорит процесс оплаты заказов.</p>',
              params: { placement: 'right', highlight: true }
            },
            {
              target: '#registration-submit',
              header: { title: 'Проверка' },
              content: 'Вы уже сейчас сможете просматривать реальные заказы, ' +
                       'а итоговая проверка закончится в течение 2 часов.',
              params: { placement: 'right', highlight: true }
            }
          ]
        }
      },
      isIdValid: ({ formData }) => formData.passport_number ? formData.passport_number.split(" ").join("").length === 10 : false
    },
    data() {
      return {
        formData: {},
        isBikValid: null,
        userType: null,
        firstName: null,
        companyName: null,
        isRussianId: true,
        fileKey: 'innFileUuid',
        isFilesPending: false,
        uploadOptions: null,
        uploadMethod: api.files.postSecurityFile,
        domainUuid: '54d0de87-99a2-4771-9c33-e9ac4ebf5fb1' // TODO remove (needed for 'postSecurityFile' method)
      }
    },
    async created() {
      const userInfo = await api.registration.auth.getUserInfo(this.userUuid);
      this.firstName = userInfo.first_name;

      this.formData = { ...this.accreditationFormData };

      const response = await api.registration.accreditation.getUserType(); // Getting userType (ИП || ЮЛ)
      this.userType = response.legalEntityCode;

      if (response.title) {
        this.formData.organisation_name = response.title;
        this.onChangeFormData('organisation_name')
      }

      this.uploadOptions = {
        participant_uuid: this.userUuid,
        domain_uuid: this.domainUuid
      }
    },
    methods: {
      ...mapActions({
        setAccreditationFormData: 'entry/setAccreditationFormData',
        setRegistrationDone: 'entry/setRegistrationDone'
      }),

      setDatepickerDirty(refName) {
        this.$refs[refName].dirty = true;
      },

      debouncedGetBikInfo: debounce(async function(data) {
        let correspondent_account = '',
            bank = '';

        try {
          const response = await api.registration.accreditation.getBikInfo(data);
          this.isBikValid = true;
          correspondent_account = response.ks;
          bank = (response.name).replace(/&quot;/g, '"');
          
        } catch(e) {
          this.isBikValid = false;
          correspondent_account = '';
          bank = '';
        }

        this.formData.correspondent_account = correspondent_account;
        this.formData.bank = bank;
        this.onChangeFormData('correspondent_account');
        this.onChangeFormData('bank');

      }, 1100),

      onChangeFormData(key) {
        const value = this.formData[key];
        this.setAccreditationFormData({ key, value });

        if (key === 'bik') {
          this.debouncedGetBikInfo(value);
        }
      },

      async onChangeFiles (e, key) {
        if (e && e.length) {
          this.setAccreditationFormData({ key, value: e[0].uuid })
        } else {
          this.setAccreditationFormData({ key, value: '' })
        }

        this.isFilesPending = false
      },

      async onSubmit() {
        let payload = {
          bik: this.accreditationFormData.bik,
          bank: this.accreditationFormData.bank,
          correspondent_account: this.accreditationFormData.correspondent_account,
          payment_account: this.accreditationFormData.payment_account
        };

        const { ceo_lastname, ceo_firstname, ceo_middlename, passportFileUuid, passport, passport_number, issued_date, dob, innFileUuid } = this.accreditationFormData;

        if (passport) {
          payload.passport = passport
        }
        if (passport_number || issued_date || dob) {
          payload.passport_number = passport_number.split(" ").join(""); //remove space between serial and number
          payload.issued_date = issued_date;
          payload.dob = dob;
        }
        if (passportFileUuid) {
          payload.passportFileUuid = passportFileUuid;
        }
        if (innFileUuid) {
          payload.innFileUuid = innFileUuid;
        }

        switch (this.userType) {

          case 'UL': {
            payload.ceo_lastname = ceo_lastname;
            payload.ceo_firstname = ceo_firstname;
            payload.ceo_middlename = ceo_middlename;

            break;
          }
        }
        console.log(payload);
        const response = await api.registration.accreditation.setUserAccreditation(payload);
        console.log(response);
        this.setRegistrationDone();
        if (response.draftOrderId) {
          this.$router.push(`order-drafts-item/${response.draftOrderId}`)
        }
      },

      clearIdData() {
        ['passportFileUuid', 'passport_number', 'issued_date', 'dob', 'passport']
          .map(key => {
            this.setAccreditationFormData({ key, value: '' });
            this.formData[key] = '';
          })
      },

      onFilesProcessStart () {
        this.isFilesPending = true
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .personal-appeal {
    @include font-mixin(14px, 18px, 400, inherit, 0.4px);
    margin-bottom: 30px;

    span {
      font-weight: bold;
    }
  }

  .step-heading {
    @include font-mixin(16px, 20px, 700, inherit, 0.4px);

    margin: 30px 0 14px;

    sup {
      color: $color-error;
    }
  }

  .step-paragraph {
    @include font-mixin(14px, 18px, 400);
    margin-bottom: 10px;
    white-space: nowrap;

    sup {
      color: $color-error;
    }
  }

  .row {
    margin-bottom: 20px;
  }

  .button-row {
    margin-top: 32px;
  }

</style>